local world = require('world')
local player = require('entities/player')

local grBlockWidth = 40
local grBlockHeight = 40
local grBlockZoneRadius = 300
local upperLeftC = false
local upperRightC = false

  local grBlock = {}
  grBlock.body = love.physics.newBody(world, -400, 200, 'static')
  grBlock.shape = love.physics.newRectangleShape(grBlockWidth, grBlockHeight)
  grBlock.fixture = love.physics.newFixture(grBlock.body, grBlock.shape)

  function grBlock.draw(self)
    love.graphics.setColor(1, 1, 1)
    x, y = self.body:getWorldPoints(self.shape:getPoints())
    love.graphics.rectangle('fill', x, y, grBlockWidth, grBlockHeight)
    love.graphics.circle('line', self.body:getX(), self.body:getY(), grBlockZoneRadius)

    if upperLeftC == true then
      love.graphics.line(topLeftX, topLeftY, self.body:getX(), self.body:getY())
    elseif upperRightC == true then
      love.graphics.line(bottomRightX, topLeftY, self.body:getX(), self.body:getY())
    end
  end

  function grBlock.update(self)
    topLeftX, topLeftY, bottomRightX = player.shape:computeAABB(player.body:getX(), player.body:getY(), 0)
    distRC = distance(bottomRightX, topLeftY, self.body:getX(), self.body:getY())
    distLC = distance(topLeftX, topLeftY, self.body:getX(), self.body:getY())

    if (distLC <= grBlockZoneRadius or distRC <= grBlockZoneRadius) and love.keyboard.isDown('k') then
      if distLC < distRC and upperRightC == false then
        upperLeftC = true
        maxJoint = love.physics.newDistanceJoint(self.body, player.body, self.body:getX(), self.body:getY(), topLeftX, topLeftY, true)
      elseif distRC < distLC and upperLeftC == false then
        upperRightC = true
        maxJoint = love.physics.newDistanceJoint(self.body, player.body, self.body:getX(), self.body:getY(), bottomRightX, topLeftY, true)
      end
    else
      upperRightC = false
      upperLeftC = false
      if maxJoint ~= nil and maxJoint:isDestroyed() == false then
        print("destroyed")
        maxJoint:destroy()
      end
    end
  end

  function distance(x1, y1, x2, y2)
    d = math.sqrt((x2 - x1) ^ 2 + (y2 - y1) ^ 2)
    return d
  end

  return grBlock
