local world = require('world')

local groundWidth = 5000
local groundHeight = 80

local ground = {}
ground.body = love.physics.newBody(world, love.graphics.getWidth()/2 + 2000, love.graphics.getHeight()/2 + 200, 'static')
ground.shape = love.physics.newRectangleShape(groundWidth, groundHeight)
ground.fixture = love.physics.newFixture(ground.body, ground.shape)
ground.fixture:setFriction(1)
ground.fixture:setCategory(2)

function ground.draw(self)
  love.graphics.setColor(0.8, 0.8, 0.8)
  x, y = self.body:getWorldPoints(self.shape:getPoints())
  love.graphics.rectangle('fill', x, y, groundWidth, groundHeight)
  love.graphics.setColor(0.2, 1, 0.2)
end

return ground
