local world = require('world')
local cameraFunc = require('libraries/STALKER-X-master/Camera')
local player = require('entities/player')
local ground = require('entities/ground')
local roof = require('entities/roof')
local grBlock = require('entities/grapple-block')

function love.load()
  camera = cameraFunc()
  camera.scale = 0.9
end

function love.draw()

  camera:attach()
  player:draw()
  ground:draw()
  grBlock:draw()
  roof:draw()

  value = 0

  love.graphics.setColor(0.8, 0.8, 0.8)
  for i = 0, 100 do
    love.graphics.rectangle('fill', value, 300, 5, 5)
    value = value + 50
  end

  camera:detach()

  --Call this if using camera:fade, camera:flash or debug drawing the deadzone
  -- camera:draw()
end

function love.update(dt)
  world:update(dt)
  camera:update(dt)
  camera:follow(player.body:getX(), player.body:getY())
  player:update(dt)
  grBlock:update()
end

function love.keypressed(key)
  if key == 'escape' then
    love.event.quit()
  end
end

--Seems to work for now
require('libraries/fixed-timestep')
